﻿using System;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Diagnostics;

namespace XamGrid_MVVM_SL
{
    public class Employees : INotifyPropertyChanged
    {
        private ObservableCollection<Employee> employeeList;

        public Employees()
        {
            this.employeeList = new ObservableCollection<Employee>();

            for (int x = 0; x < 20; x++)
            {
                this.employeeList.Add(new Employee(x, "Employee #" + x.ToString(), true, DateTime.Today,x,"Cranbury"));
            }
        }


        public ObservableCollection<Employee> EmployeeList
        {
            get { return employeeList; }
            set
            {
                employeeList = value;
                NotifyPropertyChanged("EmployeeList");
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        #endregion
    }

    public class Employee : INotifyPropertyChanged
    {
        private int employeeID;
        private string name;
        private bool onSite;
        private DateTime dateOfHire;
        private int department;
        private string site;

        public int EmployeeID
        {
            get { return this.employeeID; }
            set
            {
                this.employeeID = value;
                NotifyPropertyChanged("EmployeeID");
            }
        }

        public string Name
        {
            get { return this.name; }
            set
            {
                this.name = value;
                NotifyPropertyChanged("Name");
            }
        }

        public bool OnSite
        {
            get { return this.onSite; }
            set
            {
                this.onSite = value;
                NotifyPropertyChanged("OnSite");
            }
        }

        public DateTime DateOfHire
        {
            get 
            {
                Debug.WriteLine("Getter");
                return this.dateOfHire; 
            }
            set
            {
                Debug.WriteLine("Setter");
                this.dateOfHire = value;
                NotifyPropertyChanged("DateOfHire");
            }
        }

        public int Department
        {
            get { return this.department; }
            set
            {
                this.department = value;
                NotifyPropertyChanged("Department");
            }
        }
        public string Site
        {
            get { return this.site; }
            set
            {
                this.site = value;
                NotifyPropertyChanged("Site");
            }
        }


        public Employee()
        {
            this.employeeID = int.MinValue;
            this.name = string.Empty;
            this.onSite = false;
            this.dateOfHire = DateTime.MinValue;
            this.department = int.MinValue;
            this.site = String.Empty;
        }
        public Employee(int employeeID, string name, bool onSite, DateTime dateOfHire, int department, string site)
        {
            this.employeeID = employeeID;
            this.name = name;
            this.onSite = onSite;
            this.dateOfHire = dateOfHire;
            this.department = department;
            this.site = site;
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        #endregion
    }
}
